/*
    Header of CImmersiveWorld
    Created by Nus, 2003
    Description: Class to handle Nus' world
*/

#include <unistd.h>
#include <stdio.h>
#include <stdlib.h>
#include <strings.h>
#include <cave_ogl.h>
#include <GL/gl.h>

#include "CImmersiveWorld.h"

CImmersiveWorld::CImmersiveWorld()
{
    nav_scale = 0.3f;
    //nav_scale = 0.5f;
    //nav_rotation = 0.0f;
    //nav_rotation = 90.0f;

    nav_translation[0] = -77.0f;
    nav_translation[1] = 0.0f;
    nav_translation[2] = 73.0f;
/*
    nav_translation[0] = 0.0f;
    nav_translation[1] = 0.0f;
    nav_translation[2] = 0.0f;
*/
    nav_state = NAV_WALK;
//    axis_dep = AXIS_DEP_X;
    nav_speed = 12.0f;
    rot_speed = 10.0f;
    selected = 0;
	 course = 1;
}

CImmersiveWorld::~CImmersiveWorld()
{

}

char CImmersiveWorld::ToggleState(void)
{
    switch(nav_state)
    {
    case NAV_WALK:
    case NAV_FLOAT:
    case NAV_SCALE:
    //case OBJ_SELECT:
    //case OBJ_TRANSLATE:
    //case OBJ_ROTATE:
        nav_state++;
        break;
    default:
        nav_state = NAV_WALK;
    }
    
    return(nav_state);
}

char CImmersiveWorld::GetNavState(void)
{
    return(nav_state);
}

void CImmersiveWorld::DoTransform(void)
{
    float joyx, joyy;
    float t, dt;
    static float prev_t = 0.0f;
    float wandfvec[3];
    
    joyx = CAVE_JOYSTICK_X;
    joyy = CAVE_JOYSTICK_Y;
    t = CAVEGetTime();
    dt = (t - prev_t) * nav_speed;
    prev_t = t;
    
    if(fabs(joyy) > 0.2f)
    {
        CAVEGetVector(CAVE_WAND_FRONT_NAV, wandfvec);
        switch(nav_state)
        {
        case NAV_WALK:
            nav_translation[0] += wandfvec[0]*joyy*dt;
            nav_translation[2] += wandfvec[2]*joyy*dt;
            break;
        case NAV_FLOAT:
            nav_translation[0] += wandfvec[0]*joyy*dt;
            nav_translation[1] += wandfvec[1]*joyy*dt;
            nav_translation[2] += wandfvec[2]*joyy*dt;
            break;
        case NAV_SCALE:
            nav_scale += joyy * dt * 0.1f;
        }
    }
    
    if(fabs(joyx) > 0.2f && (nav_state == NAV_WALK || nav_state == NAV_FLOAT))
        nav_rotation -= joyx * rot_speed * dt;
}

float CImmersiveWorld::GetNavScale(void)
{
    return(nav_scale);
}

float CImmersiveWorld::GetNavRotation(void)
{
    return(nav_rotation);
}

void CImmersiveWorld::GetNavTranslation(float trans[3])
{
    trans[0] = nav_translation[0];
    trans[1] = nav_translation[1];
    trans[2] = nav_translation[2];
}

void CImmersiveWorld::SetAxisDep(char dependency)
{
    axis_dep = dependency;
}

char CImmersiveWorld::GetAxisDep(void)
{
    return(axis_dep);
}

char CImmersiveWorld::IterateAxisDep(void)
{
/*
    if(axis_dep == AXIS_DEP_X || axis_dep == AXIS_DEP_Y ||
        axis_dep == AXIS_DEP_Z || axis_dep == AXIS_DEP_XY ||
        axis_dep == AXIS_DEP_YZ || axis_dep == AXIS_DEP_XZ)
        axis_dep++;
    else
        axis_dep = AXIS_DEP_X;
    
*/
    return(axis_dep);
}

void CImmersiveWorld::SetNavSpeed(float speed)
{
    nav_speed = speed;
}

void CImmersiveWorld::SetRotSpeed(float speed)
{
    rot_speed = speed;
}
