/*
    objreader: .obj file reader's header file
*/

#ifndef __OBJ_FILE__
#define __OBJ_FILE__

#include <GL/gl.h>

#ifdef __cplusplus
extern "C" {
#endif

/* Point3D: Representation of 3D vertex in Nus' world */
typedef struct TPoint3D
{
    float x;
    float y;
    float z;
} Point3D;

/* Object3D: Representation of 3D object, use data to initialize display list */
typedef struct TObject3D
{
    char Name[256];
    GLuint DisplayListNum;      	/* Display list information */
    Point3D MinimumBoundingBox;     	/* Object position in Nus' world */
    Point3D MaximumBoundingBox;		/* Object rotation in Nus' world */
} Object3D;

/* Read material library */
/* Call this to initialize material library as necessary */
int ReadMaterialLibrary(const char *material);

/* Call this function to read .obj file & retreive the object data */
/* Use handle for the object */
GLuint ReadObject(const char *filename, Object3D *object);

#ifdef __cplusplus
}
#endif

#endif
